/**
 * Created by robin on 12/11/16.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luWebApiCrudDataAccess', ['luWebApiDataAccess', function (luWebApiDataAccess) {

            var luWebApiCrudDataAccess = {};

            luWebApiCrudDataAccess.create = function (entry_point) {
                var DataAccess = luWebApiDataAccess.create(entry_point);

                DataAccess.getSingleById = function (id, luBusyDbo) {
                    return DataAccess.get(id, null, luBusyDbo);
                };

                DataAccess.getMultiple = function (orderBy, page, perPage, luBusyDbo) {
                    return DataAccess.get('', {
                        orderBy: orderBy,
                        page: page,
                        perPage: perPage
                    }, luBusyDbo);
                };

                DataAccess.addDbo = function(data, luBusyDbo) {
                    return DataAccess.post('', null, data, luBusyDbo);
                };

                DataAccess.editSingleByIdDbo = function(id, data, luBusyDbo) {
                    return DataAccess.post(id, null, data, luBusyDbo);
                };

                DataAccess.deleteDbo = function(id, luBusyDbo) {
                    return DataAccess.delete(id, null, null, luBusyDbo);
                };

                return DataAccess;
            };

            return luWebApiCrudDataAccess;

        }]);
})();