/**
 * Created by robin on 12/11/16.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luWebApiCrudBusiness', ['luBusiness', 'luWebApiDataAccess', function (luBusiness, luWebApiDataAccess) {

            var luWebApiCrudBusiness = {};

            luWebApiCrudBusiness.create = function (dataAccess) {
                var Business = luBusiness.create();

                Business.dataAccess = dataAccess;

                Business.getSingleById = function (id, luBusyDbo) {
                    return Business.dataAccess.getSingleById(id, luBusyDbo);
                };

                Business.getMultiple = function (orderBy, page, perPage, luBusyDbo) {
                    return Business.dataAccess.getMultiple(orderBy, page, perPage, luBusyDbo);
                };

                Business.addDbo = function(data, luBusyDbo) {
                    return Business.dataAccess.addDbo(data, luBusyDbo);
                };

                Business.editSingleByIdDbo = function(id, data, luBusyDbo) {
                    return Business.dataAccess.editSingleByIdDbo(id, data, luBusyDbo);
                };

                Business.deleteDbo = function(id, luBusyDbo) {
                    return Business.dataAccess.deleteDbo(id, luBusyDbo);
                };

                return Business;
            };

            return luWebApiCrudBusiness;

        }]);
})();